<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
               "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
lang="en" xml:lang="en">
<head>
<title>The L3 language and interface </title>
<meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1"/>
<meta name="generator" content="Org-mode"/>
<meta name="generated" content="2008/04/07 12:15:27"/>
<meta name="author" content="Michael Hohn"/>
<link rel=stylesheet href="l3style.css" type="text/css" media="screen">
<link rel=stylesheet href="l3style-print.css" type="text/css" media="print">
</head><body>
<h1 class="title">The L3 language and interface </h1>



<div id="toc">
<img src="l3logo.png" border="0" alt="L3 Logo"/>
<div id="table-of-contents">
<h2>Table of Contents</h2>
<ul>
<li><a href="#sec-1">1 Overview</a></li>
<li><a href="#sec-2">2 Examples</a>
<ul>
<li><a href="#sec-3">2.1 Hello world</a></li>
<li><a href="#sec-4">2.2 Statistics via RPy</a></li>
<li><a href="#sec-5">2.3 Graphics and web data via matplotlib</a></li>
<li><a href="#sec-6">2.4 Numerical convergence</a></li>
</ul>
</li>
<li><a href="#sec-7">3 Status:  developer</a></li>
<li><a href="#sec-8">4 Documentation</a></li>
<li><a href="#sec-9">5 Installation </a>
<ul>
<li><a href="#sec-10">5.1 Using system libraries</a></li>
<li><a href="#sec-15">5.2 Self-contained installation</a></li>
</ul>
</li>
<li><a href="#sec-16">6 Licenses</a></li>
<li><a href="#sec-17">7 Developer download</a></li>
<li><a href="#sec-18">8 Developer tools</a>
<ul>
<li><a href="#sec-19">8.1 Language manipulation tools</a></li>
</ul>
</li>
<li><a href="#sec-20">9 Author / Contact info</a></li>
</ul>
</div>

<a href="http://sourceforge.net"><img src="http://sflogo.sourceforge.net/sflogo.php?group_id=214585&amp;type=2" width="125" height="37" border="0" alt="SourceForge.net Logo" /></a>
</div> 
<div id="content">
<p>
L3 is a Python-like language with convenient interaction features and a
worksheet interface. 
</p>

<div class="outline-2">
<h2 id="sec-1">1 Overview</h2>

<p>l3lang(1) is a persistent, interpreted language designed to make
interacting with scripts <i>and the data they produce</i> convenient.  It
does this by keeping track of <i>all</i> computed values (reducing file
clutter), providing nested namespaces and functions (avoiding name
clashes), and giving point-and-click access to the computed values
<i>through the script itself</i> (avoiding the filesystem detour).
</p>
<p>
It is primarily used through l3gui(1), a worksheet-style interface.
Long-running scripts can be executed without the interface, and the
results loaded later for interaction.
</p>
<p>
To avoid the need to learn yet another language, L3 is compatible with
a subset of <a href="http://www.python.org">Python</a> and can use any Python library, including
Python C/C++ extensions.  In particular, the <a href="http://www.macro-em.org/sparxwiki">sparx</a> tools (image
processing) and <a href="http://www.numpy.org">NumPy</a> (numerical linear
algebra) are known to work. The <a href="http://rpy.sourceforge.net/">RPy</a> (statistical computing via <a href="http://www.r-project.org/">R</a>)
package also works, but extra care must be taken to make sessions
persistent. 
</p>

<p>
In l3gui, every part of a script is an object and its value(s) can be
examined via mouse menus, or reinserted into the gui for use in other
scripts. 
This mechanism includes nested loops and function definitions;  all
values computed in a loop or function can be inspected later.
</p>
<p>
Scripts and code fragments can be assembled as structures,  
providing graphical script construction for problems with few steps.
</p>
</div>

<div class="outline-2">
<h2 id="sec-2">2 Examples</h2>

<p>The introduction is somewhat bland, so here are some examples to
illustrate why you may want to use L3.  They are all included with the
gui.
</p>
<div class="outline-3">
<h3 id="sec-3">2.1 Hello world</h3>

<p>The standard example, with twists. See <a href="hello.html">hello, world!</a>
</p></div>

<div class="outline-3">
<h3 id="sec-4">2.2 Statistics via RPy</h3>

<p>This example is the <a href="http://rpy.sourceforge.net/rpy_demo.html">the rpy demo</a> with minor modifications to run in
L3.  A nice example of worksheet convenience.  See the <a href="rpydemo.html">L3 rpy demo.</a>
</p></div>

<div class="outline-3">
<h3 id="sec-5">2.3 Graphics and web data via matplotlib</h3>

<p>Using the <a href="http://matplotlib.sf.net">matplotlib</a> library, this <a href="demo-matplotlib.html">demo</a> loads, graphs and
manipulates some financial data.
</p></div>

<div class="outline-3">
<h3 id="sec-6">2.4 Numerical convergence</h3>

<p>Implement a simple iteration to compute <code>sqrt(x)</code>, and examine
intermediate results.
See the <a href="sqrt.html">sqrt demo.</a>
</p>


</div>
</div>

<div class="outline-2">
<h2 id="sec-7">3 Status:  developer</h2>


<p>
The l3 language is functional with some small command-line
interface adjustments still needed.
</p>
<p>
The l3 gui is also usable, but still contains menu entries and cruft
more useful for developers than users.
</p>
<p>
Documentation is very rudimentary and gaps will be filled over the
first few months of 2008.
</p>
</div>

<div class="outline-2">
<h2 id="sec-8">4 Documentation</h2>

<p>Manual pages
</p><ul>
<li>
<a href="l3gui.html">l3gui</a> <a href="l3gui.pdf">(pdf)</a> &mdash; graphical environment for interacting with l3
programs and data.

<p>
The primary l3 interface.  Explains the use of the
interface, and shows some simple examples.
</p>
</li>
<li>
<a href="l3.html">l3</a> <a href="l3.pdf">(pdf)</a>&mdash; interpret l3 programs

<p>
The command-line interface to L3. Used to start long-running   
jobs in the background or to get an interactive toplevel.      
Computed results are kept in both cases for later examination. 
</p>

</li>
<li>
<a href="l3lang.html">l3lang</a> <a href="l3lang.pdf">(pdf)</a> &mdash; the l3 language.

<p>
The l3 language itself.  This is documentation for l3
script writing and tailoring existing Python scripts for direct use
inside l3.
</p>


</li>
</ul></div>

<div class="outline-2">
<h2 id="sec-9">5 Installation </h2>

<p>The raw files are available from the sourceforge <a href="http://sourceforge.net/projects/l3lang">project</a> page, but
read the following before installing.
</p>
<p>
l3lang and l3gui are separate packages, with different prerequisites.
</p>
<p>
l3lang only requires Python (2.4 or newer) and is  therefore trivial
to install.
</p>
<p>
l3gui requires l3lang, Python, pygtk (2.4 or newer), libgnomecanvas,
and the canvas part of the gnome-python binding.
In recent linux distributions, these are available via the package
handling system; follow the <a href="#install-system-libs">system</a> installation steps.
</p>
<p>
For older or customized systems, use the self-contained <a href="#alternate-installation">alternate installation</a> method. 
</p>
<p>
<a name="install-system-libs">&nbsp;</a>
</p>
<div class="outline-3">
<h3 id="sec-10">5.1 Using system libraries</h3>



<div class="outline-4">
<h4 id="sec-11">5.1.1 Prerequisites</h4>

<p>Newer releases of linux and FreeBSD make the prequisites available via
simple commands.  First install these prerequisites, then install L3.
</p>
<ul>
<li>
Fedora core

<p>
<pre>
  yum install  gnome-python2-canvas
</pre>
</p>
</li>
<li>
Ubuntu / Debian

<p>
<pre>
 apt-get install  python-gnomecanvas
</pre>
</p>


</li>
</ul></div>

<div class="outline-4">
<h4 id="sec-12">5.1.2 Download L3</h4>

<p>To install l3 proper, download <a href="http://downloads.sourceforge.net/l3lang/l3np/l3lang-0.3.1.tar.gz">l3lang-0.3.1.tar.gz</a> and <a href="http://downloads.sourceforge.net/l3lang/l3gui-0.3.1.tar.gz">l3gui-0.3.1.tar.gz</a>, extract
them, and run setup.py.  The download steps using the shell are:
<pre>
    cd /tmp
    wget http://downloads.sourceforge.net/l3lang/l3lang-0.3.1.tar.gz
    wget http://downloads.sourceforge.net/l3lang/l3gui-0.3.1.tar.gz
    tar zxf l3lang-0.3.1.tar.gz
    tar zxf l3gui-0.3.1.tar.gz
</pre>
</p>

</div>

<div class="outline-4">
<h4 id="sec-13">5.1.3 Install L3</h4>

<p>Installation can be to system directories, a local directory, or l3
can be run from the distribution directory without installation.  
Choose <b>one</b>    of the following.
</p>
<ul>
<li>System installation<br/>
System installation is done via 
<pre>
    cd l3lang-0.3.1
    python setup.py install --record INSTALLED-FILES
    cd ../l3gui
    python setup.py install --record INSTALLED-FILES
</pre>
but requires root access.

</li>
<li>Installation to prefix<br/>
Installation to a local directory is supported; the minimal 
shell setup for bash/ksh for using a local directory 
<code>$HOME/linux-local</code> with Python 2.4 is:
<pre>
   export PYVERSION=2.4
   export MYPREFIX=$HOME/linux-local
   export PATH=$MYPREFIX/bin:$PATH
   export PYTHONPATH=$MYPREFIX/lib/python${PYVERSION}/site-packages:$PYTHONPATH 
   export MANPATH=$MYPREFIX/man:$MYPREFIX/share/man:$MANPATH
</pre>

<p>
followed by installation via
<pre>
   cd l3lang-0.3.1
   python setup.py  install --prefix=$MYPREFIX --record INSTALLED-FILES
   cd ../l3gui-0.3.1
   python setup.py  install --prefix=$MYPREFIX --record INSTALLED-FILES
</pre>
</p>
<p>
<a name="use&ndash;without&ndash;installation">&nbsp;</a>
</p></li>
<li>Use without installation<br/>
The minimalistic adjustments are to ignore the installation step and only set
the PATH, PYTHONPATH, and MANPATH:
<pre>
   export PYTHONPATH=`pwd`/l3gui:`pwd`/l3lang:$PYTHONPATH 
   export PATH=`pwd`/l3gui/bin:`pwd`/l3lang/bin:$PATH
   export MANPATH=`pwd`/l3gui/doc/man:`pwd`/l3lang/doc/man:$MANPATH
</pre>
This requires removing the version number:
<pre>
   mv l3lang-0.3.1 l3lang
   mv l3gui-0.3.1 l3gui
   chmod a+x l3lang/bin/*    l3gui/bin/*
</pre>

</li>
</ul>
</div>

<div class="outline-4">
<h4 id="sec-14">5.1.4 Quick test</h4>

<p>Once installed, a quick installation check can be done by reading the
documentation and running the toplevel: 
<pre>
   man l3
   man l3gui
   l3
</pre>
Or run the gui via
<pre>
   l3gui
</pre>
</p>
<p>
<a name="alternate-installation">&nbsp;</a>
</p></div>
</div>

<div class="outline-3">
<h3 id="sec-15">5.2 Self-contained installation</h3>

<p>An installer based on <a href="http://www.gnome.org/projects/garnome">GARNOME</a> (itself based on the <a href="http://lnx-bbc.com/">linux-bbc</a> gar build
setup) is available.  This provides a local environment for using /
incorporating other packages outside the system's package handler
(rpm/dpkg/pkg_add), which is particularly useful for 
</p><ul>
<li>
  older linux/UNIX versions lacking the gtk/gnome canvas;
</li>
<li>
  a self-contained installation to a local directory, including
environment-setting scripts and other niceties; 
</li>
<li>
  multiple independent development trees.

</li>
</ul>
<p>This installer is used for the <a href="http://www.macro-em.org/sparxwiki/">sparx</a> project that l3 is part of and
contains rules for many more packages, but
installation of the L3 subset is simple.
</p>
<p>
Installation from source can be done as follows.
</p>
<p>
First:
</p>
<p>
<pre>
    mkdir /your/installer/path
    cd /your/installer/path
</pre>
</p>
<p>
Then, preferably:
</p>
<p>
<pre>
    svn co svn://cci.lbl.gov/sparx-installer/trunk \
        sparx-installer
</pre>
</p>
<p>
If you do not have subversion, and don't mind reinstalling everything
occasionally, you can instead use this: 
</p>
<p>
<pre>
    wget http://cci.lbl.gov/~hohn/sparx-installer.tar.gz
    tar zxvf sparx-installer.tar.gz
</pre>
</p>
<p>
If you don't have wget, try curl instead:
</p>
<p>
<pre>
    curl http://cci.lbl.gov/~hohn/sparx-installer.tar.gz -o sparx-installer.tar.gz
</pre>
</p>
<p>
Then:
<pre>
    cd sparx-installer
    ./configure /your/sparxroot
</pre>
</p>
<p>
The last step (./configure) will print a summary. If there are any
errors, your system is missing the listed prerequisite(s).  
</p>
<p>
The install is done via
<pre>
    cd sparx/l3gui
    make install
</pre>
</p>
<p>
When run successfully, this takes between 1.5 and 2.5 hours,
depending on the machine used.
</p>



</div>
</div>

<div class="outline-2">
<h2 id="sec-16">6 Licenses</h2>

<ul>
<li>
PLY 1.3.1 &ndash; LGPL

<p>
L3 uses version 1.3.1 of <a href="http://www.dabeaz.com/ply/">PLY</a>, a yacc-like parser generator for Python.
Ply is included in the L3 source tree for convenience, but is released
under the GNU Lesser General Public License as published by the Free
Software Foundation; either version 2.1 of the License, or (at your
option) any later version.
</p>
</li>
<li>
L3 &ndash; BSD

<p>
L3 itself is released under the following license.
</p>
<p>
Copyright (c) 2006, The Regents of the University of California,
through Lawrence Berkeley National Laboratory.  All rights
reserved.
</p>
<p>
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
</p>
<p>
(1) Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
</p>
<p>
(2) Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
</p>
<p>
(3) Neither the name of the University of California, Lawrence
Berkeley National Laboratory, U.S. Dept. of Energy nor the names
of its contributors may be used to endorse or promote products
derived from this software without specific prior written
permission.
</p>
<p>
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
</p>
<p>
You are under no obligation whatsoever to provide any bug fixes,
patches, or upgrades to the features, functionality or performance of
the source code ("Enhancements") to anyone; however, if you choose to
make your Enhancements available either publicly, or directly to
Lawrence Berkeley National Laboratory, without imposing a separate
written license agreement for such Enhancements, then you hereby grant
the following license: a non-exclusive, royalty-free perpetual license
to install, use, modify, prepare derivative works, incorporate into
other computer software, distribute, and sublicense such enhancements
or derivative works thereof, in binary and source code form.
</p>



</li>
</ul></div>

<div class="outline-2">
<h2 id="sec-17">7 Developer download</h2>

<p>Development is done using <a href="http://git.or.cz/">git</a> so anyone can have their own local
development branches.  The web interface is at <a href="http://repo.or.cz/w/l3full.git">repo.or.cz</a>, and you can
get the whole repository including l3doc, -lang, and -gui via
<pre>
git-clone git://repo.or.cz/l3full.git l3full
</pre>
</p>
<p>
The working directories can be directly used with appropriate
settings, via  minimalistic adjustments:
<pre>
   cd l3full
   export PYTHONPATH=`pwd`:$PYTHONPATH 
   export PATH=`pwd`/l3gui/bin:`pwd`/l3lang/bin:$PATH
   export MANPATH=`pwd`/l3gui/doc/man:`pwd`/l3lang/doc/man:$MANPATH
</pre>
</p>



</div>

<div class="outline-2">
<h2 id="sec-18">8 Developer tools</h2>

<p>Several parts of <code>l3lang</code> can be used as libraries for other
purposes. 
</p>

<div class="outline-3">
<h3 id="sec-19">8.1 Language manipulation tools</h3>

<p>L3 parser / pattern matcher / pretty printer
</p>
<p>
The <code>l3lang.reader</code> module implements the l3 parser, currently using
the Python <code>tokenize</code> module and a <a href="http://www.dabeaz.com/ply">PLY</a> grammar to parse input text and
produce the l3 AST.
</p>

<p>
The <code>l3lang.pretty</code> module is a box-based pretty-printer providing
horizontal (H) vertical (V), and horizontal-or-vertical (HOV) boxes.
It is a transliteration from the <a href="http://citeseer.ist.psu.edu/301975.html">ocaml version</a> of Wadler's pretty
printer.
</p>
<p>
<code>l3lang.ast</code> provides AST manipulation tools, including a simple
pattern matcher.
</p>
<p>
<code>l3lang.view</code> provides tools for printing the AST.  Two functions of
general interest are <code>get_infix_string()</code> which returns a
pretty-printed representation of an AST, 
and <code>print_info()</code> which produces a prefix dump of the AST.
</p>

<p>
As example, the full read / print cycle starts from
</p>
<p>
<pre>
tree = reader.parse('''
a = 1
def loop(a):
    if a &lt; 3:
        print a
        loop(a + 1)
loop(1)
''')
</pre>
</p>
<p>
Then, 
<pre>
print tree.get_infix_string(40)
</pre>
gives
<pre>
program:
    a=1
    def loop(a):
        if (a &lt; 3):
            print_(a);loop((a + 1))
    loop(1)
</pre>
while 
<pre>
print tree.get_infix_string(10)
</pre>
tries to squeeze more:
<pre>
program:
    a=1
    def loop(a):
        if (a
        &lt;
        3):
            print_(a)
            loop((a
                +
                1))
    loop(1)
</pre>
</p>

</div>
</div>

<div class="outline-2">
<h2 id="sec-20">9 Author / Contact info</h2>






</div> 
</div>
<div id="postamble"><p class="author"> Author: Michael Hohn
<a href="mailto:mhhohn at users dot sourceforge.net">&lt;mhhohn at users dot sourceforge.net&gt;</a>
</p>
<p class="date"> Date: 2008/04/07 12:15:27</p>
</div></body>
</html>
